diff -ru hurd-0.0/daemons/ChangeLog hurd-0.1/daemons/ChangeLog
--- hurd-0.0/daemons/ChangeLog	Sat Jul 20 11:04:19 1996
+++ hurd-0.1/daemons/ChangeLog	Wed Aug 14 14:04:35 1996
@@ -1,3 +1,13 @@
+Wed Aug 14 10:22:39 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* Makefile (getty-LDLIBS): New variable.
+	(getty): Dependency on -lutil removed.
+	(libutil-libsubst): Variable removed.
+
+Tue Aug 13 08:13:04 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* rc.sh: When deleting files from /tmp, use -f flag to rm.
+
 Sat Jul 20 01:06:07 1996  Miles Bader  <miles@gnu.ai.mit.edu>
 
 	* getty.c (main): Get the tty name from the right element in ARGV.
diff -ru hurd-0.0/daemons/Makefile hurd-0.1/daemons/Makefile
--- hurd-0.0/daemons/Makefile	Sat Jul  6 00:19:03 1996
+++ hurd-0.1/daemons/Makefile	Wed Aug 14 14:04:35 1996
@@ -26,14 +26,13 @@
 installationdir = $(libexecdir)
 
 OBJS = $(SRCS:.c=.o)
-
-libutil-libsubst = -lutil
+getty-LDLIBS = -lutil
 
 include ../Makeconf
 
-%: %.sh
-	cp $< $@ && chmod +w $@
-
-getty: ../libshouldbeinlibc/libshouldbeinlibc.a -lutil
+getty: ../libshouldbeinlibc/libshouldbeinlibc.a
 
 $(filter-out $(special-targets), $(targets)): %: %.o
+
+%: %.sh
+	cp $< $@ && chmod +w $@
diff -ru hurd-0.0/daemons/rc.sh hurd-0.1/daemons/rc.sh
--- hurd-0.0/daemons/rc.sh	Mon Jul 15 17:27:17 1996
+++ hurd-0.1/daemons/rc.sh	Tue Aug 13 08:11:51 1996
@@ -46,7 +46,7 @@
 rm -f /etc/nologin
 rm -f /var/lock/LCK.*
 if test -d /tmp; then
-  (cd /tmp; find . ! -name . ! -name lost+found ! -name quotas -exec rm -r {} \; )
+  (cd /tmp; find . ! -name . ! -name lost+found ! -name quotas -exec rm -rf {} \; )
 fi
 if test -d /var/run; then
   (cd /var/run && { rm -rf -- *; cp /dev/null utmp; chmod 644 utmp; })
diff -ru hurd-0.0/exec/ChangeLog hurd-0.1/exec/ChangeLog
--- hurd-0.0/exec/ChangeLog	Wed Jul 17 18:54:46 1996
+++ hurd-0.1/exec/ChangeLog	Thu Sep  5 11:12:05 1996
@@ -1,3 +1,23 @@
+Thu Sep  5 11:11:19 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* main.c: Include <version.h>.
+	(exec_version): Delete variable.
+ 	(S_exec_init): Pass empty string as release; HURD_VERSION
+	as version.
+
+Thu Aug 29 13:00:38 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* priv.h: Only include <bfd.h> if BFD.  Only declare
+	host_bfd_arc_info, and bfd_host_bfd if BFD.  If not BFD, give
+	typedef for asection. 
+	* main.c: Only define host_bfd_arch_info, host_bfd, and
+	bfd_mach_host_arch_mach if BFD.  
+	(main): Only call bfd_mach_most_arch_mach if BFD.
+	Call mach_host_elf_machine.
+	* hostarch.c (bfd_mach_host_arch_mach): Only define if BFD.
+	Delete arg E_MACHINE.  All callers changed.
+	(mach_host_elf_machine): New function.
+
 Sun Jul  7 21:13:22 1996  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>
 
 	* exec.c (S_exec_exec): Don't use unsafe MOVE_SEND in call to
diff -ru hurd-0.0/exec/hostarch.c hurd-0.1/exec/hostarch.c
--- hurd-0.0/exec/hostarch.c	Thu Jul  6 22:12:51 1995
+++ hurd-0.1/exec/hostarch.c	Thu Aug 29 13:33:13 1996
@@ -1,6 +1,6 @@
 /* Determine the BFD and ELF architecture and machine flavor
    from a Mach host port.  Used by the exec and core servers.
-   Copyright (C) 1992, 1993, 1995 Free Software Foundation, Inc.
+   Copyright (C) 1992, 1993, 1995, 1996 Free Software Foundation, Inc.
    Written by Roland McGrath.
 
 This file is part of the GNU Hurd.
@@ -19,17 +19,68 @@
 along with the GNU Hurd; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */
 
+
 #include <mach.h>
 #include <hurd/hurd_types.h>
 #include <errno.h>
-#include <bfd.h>
 #include <elf.h>
 
 error_t
+mach_host_elf_machine (host_t host,
+		       Elf32_Half *e_machine)
+{
+  error_t err;
+  struct host_basic_info hostinfo;
+  mach_msg_type_number_t hostinfocnt = HOST_BASIC_INFO_COUNT;
+
+  err = host_info (host, HOST_BASIC_INFO, 
+		   (natural_t *) &hostinfo, &hostinfocnt);
+  if (err)
+    return err;
+
+  switch (hostinfo.cpu_type)
+    {
+    default:
+      *e_machine = EM_NONE;
+      break;
+
+    case CPU_TYPE_MC68020:
+    case CPU_TYPE_MC68030:
+    case CPU_TYPE_MC68040:
+      *e_machine = EM_68K;
+      break;
+
+    case CPU_TYPE_I860:
+      *e_machine = EM_860;
+      break;
+
+    case CPU_TYPE_MIPS:
+      *e_machine = EM_MIPS;
+      break;
+
+    case CPU_TYPE_MC88000:
+      *e_machine = EM_88K;
+      break;
+
+    case CPU_TYPE_SPARC:
+      *e_machine = EM_SPARC;
+      break;
+
+    case CPU_TYPE_I386:
+      *e_machine = EM_386;
+      break;
+    }
+
+  return 0;
+}
+
+#ifdef BFD
+#include <bfd.h>
+
+error_t
 bfd_mach_host_arch_mach (host_t host,
 			 enum bfd_architecture *arch,
-			 long int *machine,
-			 Elf32_Half *e_machine)
+			 long int *machine)
 {
   error_t err;
   struct host_basic_info hostinfo;
@@ -117,3 +168,5 @@
 
   return 0;
 }
+
+#endif /* BFD */
diff -ru hurd-0.0/exec/main.c hurd-0.1/exec/main.c
--- hurd-0.0/exec/main.c	Mon May  6 14:26:35 1996
+++ hurd-0.1/exec/main.c	Thu Sep  5 11:12:09 1996
@@ -1,5 +1,5 @@
 /* GNU Hurd standard exec server, main program and server mechanics.
-   Copyright (C) 1992, 1993, 19941996 Free Software Foundation, Inc.
+   Copyright (C) 1992, 1993, 19941996, 1996 Free Software Foundation, Inc.
    Written by Roland McGrath.
 
 This file is part of the GNU Hurd.
@@ -22,17 +22,18 @@
 #include <error.h>
 #include <hurd/paths.h>
 #include <hurd/startup.h>
+#include <version.h>
 
-
+#ifdef BFD
 bfd_arch_info_type host_bfd_arch_info;
 bfd host_bfd = { arch_info: &host_bfd_arch_info };
-Elf32_Half elf_machine;	/* ELF e_machine for the host.  */
-
 extern error_t bfd_mach_host_arch_mach (host_t host,
 					enum bfd_architecture *bfd_arch,
 					long int *bfd_machine,
 					Elf32_Half *elf_machine);
+#endif
 
+Elf32_Half elf_machine;	/* ELF e_machine for the host.  */
 
 /* Trivfs hooks.  */
 int trivfs_fstype = FSTYPE_MISC;
@@ -49,7 +50,6 @@
 
 struct trivfs_control *fsys;
 
-char *exec_version = "0.0";
 char **save_argv;
 
 
@@ -116,12 +116,15 @@
 
   save_argv = argv;
 
+#ifdef BFD
   /* Put the Mach kernel's idea of what flavor of machine this is into the
      fake BFD against which architecture compatibility checks are made.  */
   err = bfd_mach_host_arch_mach (mach_host_self (),
 				 &host_bfd.arch_info->arch,
-				 &host_bfd.arch_info->mach,
-				 &elf_machine);
+				 &host_bfd.arch_info->mach);
+#endif
+  err = mach_host_elf_machine (mach_host_self (), &elf_machine);
+  
   if (err)
     error (1, err, "Getting host architecture from Mach");
 
@@ -249,8 +252,7 @@
   err = get_privileged_ports (&host_priv, &dev_master);
   if (!err)
     {
-      proc_register_version (procserver, host_priv, "exec", HURD_RELEASE,
-			     exec_version);
+      proc_register_version (procserver, host_priv, "exec", "", HURD_VERSION);
       mach_port_deallocate (mach_task_self (), dev_master);
       err = proc_getmsgport (procserver, 1, &startup);
       if (err)
diff -ru hurd-0.0/exec/priv.h hurd-0.1/exec/priv.h
--- hurd-0.0/exec/priv.h	Tue Oct 24 19:21:09 1995
+++ hurd-0.1/exec/priv.h	Thu Aug 29 13:28:12 1996
@@ -1,5 +1,5 @@
 /* GNU Hurd standard exec server, private declarations.
-   Copyright (C) 1992, 1993, 1994, 1995 Free Software Foundation, Inc.
+   Copyright (C) 1992, 1993, 1994, 1995, 1996 Free Software Foundation, Inc.
    Written by Roland McGrath.
 
 This file is part of the GNU Hurd.
@@ -26,7 +26,11 @@
 #include <hurd/ports.h>
 #include <hurd/lookup.h>
 #include <rwlock.h>
+
+#ifdef BFD
 #include <bfd.h>
+#endif
+
 #include <elf.h>
 #include <fcntl.h>
 #include "exec_S.h"
@@ -35,11 +39,13 @@
 #ifndef exec_priv_h
 #define exec_priv_h
 
+#ifdef BFD
 /* A BFD whose architecture and machine type are those of the host system.  */
 extern bfd_arch_info_type host_bfd_arch_info;
 extern bfd host_bfd;
-extern Elf32_Half elf_machine;	/* ELF e_machine for the host.  */
+#endif
 
+extern Elf32_Half elf_machine;	/* ELF e_machine for the host.  */
 
 /* Information kept around to be given to a new task
    in response to a message on the task's bootstrap port.  */
@@ -67,6 +73,9 @@
 
 extern mach_port_t procserver;	/* Our proc port.  */
 
+#ifndef BFD
+typedef void asection;
+#endif
 
 /* Data shared between check, check_section,
    load, load_section, and finish.  */
diff -ru hurd-0.0/ext2fs/ChangeLog hurd-0.1/ext2fs/ChangeLog
--- hurd-0.0/ext2fs/ChangeLog	Fri Aug  2 16:23:20 1996
+++ hurd-0.1/ext2fs/ChangeLog	Fri Sep  6 16:05:28 1996
@@ -1,3 +1,79 @@
+Fri Sep  6 16:03:11 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* ext2fs.c: Include <version.h>.
+	(diskfs_major_version, diskfs_minor_version, diskfs_edit_version):
+	Deleted variables.
+	(diskfs_server_version): New variable.
+
+Thu Aug 29 16:59:51 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	Changes from ufs/dir.c:
+	* dir.c (diskfs_lookup_hard): When setting ds->stat to EXTEND, set
+ 	ds->idx by looking at the size of the file.  After successful
+ 	dirscanblock, record index where we finished in DP->dn->dir_idx.
+  	Start searches at that index.
+	(dirscanblock): Size dirents correctly when mallocing it.
+	(diskfs_direnter_hard): Be more careful when sizing or resizing
+	dirents.  Correctly set to -1 all the new entries we create after
+	realloc call.   
+	* ext2fs.h (struct disknode): New member `dir_idx'.
+	* inode.c (diskfs_cached_lookup): Initialize DN->dir_idx.
+
+	* dir.c (diskfs_direnter_hard): Initialize OLDSIZE to quiet gcc.
+
+Sun Aug 18 01:45:42 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* pager.c (file_pager_read_page): Use get_page_buf to get a free page.
+	(file_pager_read_page): Use free_page_buf to deallocate pages.
+	* ext2fs.c (get_page_buf): Return 0 if we can't allocate.
+
+Thu Aug 15 14:55:01 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* ext2fs.c (diskfs_edit_version): Change to `1'.
+	(diskfs_version_extra): New variable.
+	* inode.c (read_disknode): Change assertion to allow non-zero
+	st_size for anything, but assert that st_blocks == 0 for any case
+	where we set allocsize to 0.
+	* truncate.c (diskfs_truncate): Allow any sort of node to have a
+	size without any blocks (as linux apparently does this sometimes
+	with devices).
+
+Wed Aug 14 14:03:33 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* ext2fs.c (diskfs_minor_version): Change to `2'.
+
+Tue Aug 13 15:11:42 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* ext2_fs.h: Update to version from linux-2.0.12.
+	* ialloc.c (ext2_alloc_inode, diskfs_free_node): Pass SBLOCK as a
+	parameter to EXT2_FIRST_INO (v2.x change).
+	* hyper.c (get_hypermetadata): Use EXT2_INODE_SIZE instead of
+	sizeof (struct ext2_inode).
+	Deal with various version 2.x features.
+	* ext2fs.h (dino): Dont recalculate INODES_PER_BLOCK here.
+	(ext2_debug): redefine macro after including ext2_fs.h.
+	
+Mon Aug 12 13:48:17 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* ext2fs.c (diskfs_minor_version): Changed to `1'.
+
+	* inode.c (read_disknode): Don't set allocsize for in-inode symlinks.
+	(MAX_INODE_SYMLINK): New macro.
+	(write_symlink, read_symlink): New functions.
+	(diskfs_create_symlink_hook, diskfs_read_symlink_hook): New variables.
+	* truncate.c (diskfs_truncate): For in-inode symlinks, just frob
+	the size.
+
+	* ext2fs.h (__u32, __u16, __u8, __s32, __s16, __s8): New types.
+	* ext2_fs.h (u32, u16, u8, s32, s16, s8): All uses of these types
+	changed to have a leading `__', and the definitions removed.
+	* ext2_fs_i.h (u32, u16, u8, s32, s16, s8): All uses of these types
+	changed to have a leading `__'.
+
+Mon Aug 12 11:18:37 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* hyper.c (diskfs_set_hypermetadata): Return an error code now.
+
 Fri Aug  2 12:10:40 1996  Miles Bader  <miles@gnu.ai.mit.edu>
 
 	* inode.c (diskfs_write_disknode): If WAIT is false, still record
diff -ru hurd-0.0/ext2fs/dir.c hurd-0.1/ext2fs/dir.c
--- hurd-0.0/ext2fs/dir.c	Tue Jun 25 17:31:35 1996
+++ hurd-0.1/ext2fs/dir.c	Tue Sep  3 10:20:41 1996
@@ -119,7 +119,8 @@
   vm_address_t buf = 0;
   vm_size_t buflen = 0;
   int blockaddr;
-  int idx;
+  int idx, lastidx;
+  int looped;
   
   if ((type == REMOVE) || (type == RENAME))
     assert (npp);
@@ -164,18 +165,39 @@
   if (!diskfs_check_readonly ())
     dp->dn_set_atime = 1;
   
-  for (blockaddr = buf, idx = 0;
-       blockaddr - buf < dp->dn_stat.st_size;
-       blockaddr += DIRBLKSIZ, idx++)
+  /* Start the lookup at DP->dn->dir_idx.  */
+  idx = dp->dn->dir_idx;
+  if (idx * DIRBLKSIZ > dp->dn_stat.st_size)
+    idx = 0;			/* just in case */
+  blockaddr = buf + idx * DIRBLKSIZ;
+  looped = (idx == 0);
+  lastidx = idx;
+  if (lastidx == 0)
+    lastidx = dp->dn_stat.st_size / DIRBLKSIZ;
+
+  while (!looped || idx < lastidx)
     {
       err = dirscanblock (blockaddr, dp, idx, name, namelen, type, ds, &inum);
       if (!err)
-	break;
+	{
+	  dp->dn->dir_idx = idx;
+	  break;
+	}
       if (err != ENOENT)
 	{
 	  vm_deallocate (mach_task_self (), buf, buflen);
 	  return err;
 	}
+
+      blockaddr += DIRBLKSIZ;
+      idx++;
+      if (blockaddr - buf >= dp->dn_stat.st_size && !looped)
+	{
+	  /* We've gotten to the end; start back at the beginning */
+	  looped = 1;
+	  blockaddr = buf;
+	  idx = 0;
+	}
     }
 
   if (!diskfs_check_readonly ())
@@ -266,7 +288,7 @@
       /* We didn't find any room, so mark ds to extend the dir */
       ds->type = CREATE;
       ds->stat = EXTEND;
-      ds->idx = idx;
+      ds->idx = dp->dn_stat.st_size / DIRBLKSIZ;
     }
 
   /* Return to the user; if we can't, release the reference
@@ -428,8 +450,8 @@
 	 down how many entries there were. */
       if (!dp->dn->dirents)
 	{
-	  dp->dn->dirents = malloc ((dp->dn_stat.st_size / DIRBLKSIZ + 1) 
-				* sizeof (int));
+	  dp->dn->dirents = malloc ((dp->dn_stat.st_size / DIRBLKSIZ) 
+				    * sizeof (int));
 	  for (i = 0; i < dp->dn_stat.st_size/DIRBLKSIZ; i++) 
 	    dp->dn->dirents[i] = -1;
 	}
@@ -475,7 +497,7 @@
   vm_address_t fromoff, tooff;
   int totfreed;  
   error_t err;
-  off_t oldsize;
+  off_t oldsize = 0;
 
   assert (ds->type == CREATE);
   
@@ -590,19 +612,26 @@
     }
   else
     {
+      int i;
       /* It's cheap, so start a count here even if we aren't counting
 	 anything at all. */
       if (dp->dn->dirents)
 	{
 	  dp->dn->dirents = realloc (dp->dn->dirents, 
-				     (ds->idx + 1) * sizeof (int));
+				     (dp->dn_stat.st_size / DIRBLKSIZ
+				      * sizeof (int)));
+	  for (i = oldsize / DIRBLKSIZ; 
+	       i < dp->dn_stat.st_size / DIRBLKSIZ;
+	       i++)
+	    dp->dn->dirents[i] = -1;
+
 	  dp->dn->dirents[ds->idx] = 1;
 	}
       else
 	{
-	  int i;
-	  dp->dn->dirents = malloc ((ds->idx + 1) * sizeof (int));
-	  for (i = 0; i < ds->idx; i++)
+	  dp->dn->dirents = malloc (dp->dn_stat.st_size / DIRBLKSIZ 
+				    * sizeof (int));
+	  for (i = 0; i < dp->dn_stat.st_size / DIRBLKSIZ; i++)
 	    dp->dn->dirents[i] = -1;
 	  dp->dn->dirents[ds->idx] = 1;
 	}
